abstract class FenwickTreeGroup<T> implements FenwickTreeMonoid<T> {
  /// The 'minus' operation.
  T inverse(
    final T left,
    final T right,
  );
}

abstract class FenwickTreeMonoid<T> {
  /// The identity value.
  T identity();

  /// The 'add' operation.
  T operate(
    final T left,
    final T right,
  );
}
